#ifndef __DIBALP_H__
#define __DIBALP_H__

#pragma comment(lib,"msimg32.lib")

class CDib2 {
public:
	CDib2(int width, int height);
	CDib2(char *file_name, int x = 0, int y = 0, int width = 0, int height = 0);
	
	int		GetWidth()	{ return m_width;  }
	int		GetHeight()	{ return m_height; }
	HBITMAP	GetHBmp()	{ return m_hbmp;   }
	PDWORD	GetPBits()	{ return m_buf;    }
	
	~CDib2();
	
private:
	HBITMAP	m_hbmp;
	PDWORD	m_buf;
	int		m_width;
	int 	m_height;
	
	void CreateDib(int width, int height);
	bool LoadFile(char *file_name, int x = 0, int y = 0, int width = 0, int height = 0);
};

#endif