////////////////////////////////////////////////////////////////////////////
//	t@C	F	win_main.cpp
//	t@CTvF	EChẼCsB
//					VXen̔ėp֐̐錾̃t@CɂčsB
//	쐬		F	M.Minami
////////////////////////////////////////////////////////////////////////////
#include "win_main.h"

#include "dib_buf.h"
#include "sound.h"
#include "scr_change.h"

#include "game.h"
#include <imm.h>

#pragma comment(lib,"imm32.lib")

////////////////////////////////////////////////////////////////////////////
//                        O[oϐ̐錾
////////////////////////////////////////////////////////////////////////////
static HWND 	 g_hwnd;					// EBhEnh
static HINSTANCE g_Instance;				// CX^Xnh

static int 		 g_MousPosX;				// }EXWۑpϐ
static int 		 g_MousPosY;

float			 g_FrameTime = 0.0;			// ɂԂi[
static long		 g_PreTime;

static bool		 g_ScrMode = WINDOW_MODE;	// tXN[AEChE[hؑ֗p

HIMC	g_hIMC = NULL;

////////////////////////////////////////////////////////////////////////////
//                     t@CԃC^[tF[X֐
////////////////////////////////////////////////////////////////////////////
float	GetSysFrmTime(void)  { return g_FrameTime; }
HWND	GetSysHwnd(void) 	 { return g_hwnd; }
int 	GetSysMousPosX(void) { return g_MousPosX; }
int 	GetSysMousPosY(void) { return g_MousPosY; }

////////////////////////////////////////////////////////////////////////////
//                          vg^Cv錾
////////////////////////////////////////////////////////////////////////////
static long FAR PASCAL WindowProc(HWND, UINT, WPARAM, LPARAM);
static BOOL SysCreateWindow(HINSTANCE hInstance, int nCmdShow);
static void SysMainLoop(void);

void  SysErrMsgDisp(char *msg);
char* SysDirGet(void);
void  SysKeyGet(unsigned int code,int* state);

	
////////////////////////////////////////////////////////////////////////////
//	֐	F	WinMain
//	TvF	EChEC֐
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance, LPSTR lpCmdLine,int nCmdShow)
{
	// dNh~
    if (FindWindow(WINDOW_NAME, NULL) != NULL) return FALSE;

	//======================================================================
	//						  EChE
	//======================================================================
	if (SysCreateWindow(hInstance, nCmdShow) == FALSE) return FALSE;

	//======================================================================
	//							  
	//======================================================================
	// cha
	DIB_INIT();

	// n񏉊
	srand(timeGetTime());
	
	// ^C}[̐xPɕύX
	timeBeginPeriod(1);

	//======================================================================
	//							C[v
	//======================================================================
	SysMainLoop();

	//======================================================================
	//							  I
	//======================================================================
	timeEndPeriod(1);						// ^C}[̐x𕜋A

	return TRUE;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	WindowProc
//	TvF	bZ[W֐
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
long FAR PASCAL WindowProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	switch (msg)
	{
		case WM_CREATE:
			g_hwnd = hwnd;
			GameInit();
			break;
		case WM_SHOWWINDOW:
			g_hIMC = ImmAssociateContext(hwnd, NULL);
			break;
		case WM_SIZE:
			{
				// EBhËʒuƃTCYύX
				DWORD dwStyle = GetWindowStyle(hwnd);
				if(!(dwStyle & WS_OVERLAPPED)){	// tXN[ꍇ
					dwStyle |= WS_OVERLAPPED | WS_CAPTION;
					RECT rc = {0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
					AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
					int		widthDT		= GetSystemMetrics(SM_CXSCREEN);
					int		heightDT	= GetSystemMetrics(SM_CYSCREEN);
					int		width = rc.right - rc.left;
					int		height = rc.bottom - rc.top;
					int		x = (widthDT - width) / 2;
					int		y = (heightDT - height) / 2;
					MoveWindow(hwnd, x, y, width, height, TRUE);
				}
			}
			break;
		// }EXW擾 --------------------------------------------------
		case WM_MOUSEMOVE:
			g_MousPosX = LOWORD(lParam);
			g_MousPosY = HIWORD(lParam);
			break;
		// L[ꂽꍇ ------------------------------------------
		case WM_KEYDOWN:
			switch (wParam) {
			case VK_F12:
				if (g_ScrMode == WINDOW_MODE) {
					// XN[[hύXitXN[[hցj
					g_ScrMode = FULLSCREEN_MODE;
					ScrModeChange(hwnd, FULLSCREEN_MODE);
				} else {	
					// XN[[hύXiEChE[hցj
					g_ScrMode = WINDOW_MODE;
					ScrModeChange(hwnd, WINDOW_MODE);
				}
				break;
			}
			break;
		// EBhEꍇ --------------------------------------
		case WM_CLOSE:
			ImmAssociateContext(hwnd, g_hIMC);
			if (g_ScrMode == FULLSCREEN_MODE) {
				// XN[[hύXiEChE[hցj
				g_ScrMode = WINDOW_MODE;
				ScrModeChange(hwnd, WINDOW_MODE);
			}
			DestroyWindow(hwnd);
			return 0L;
		// EBhEjꍇ --------------------------------------
		case WM_DESTROY:
			PostQuitMessage(0); // I
			break;
	}
	
	return DefWindowProc(hwnd,msg,wParam,lParam);
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	SysCreateWindow
//	TvF	EChE֐
//		F	hInstance	CX^Xnh
//			F	nCmdShow	EChE\
//	o	F	TRUE		EChE쐬
//			F	FALSE		EChE쐬s
////////////////////////////////////////////////////////////////////////////
BOOL SysCreateWindow(HINSTANCE hInstance, int nCmdShow)
{
	//======================================================================
	//						 EChENX̍쐬
	//======================================================================
	WNDCLASS    wc;	
	wc.style		 = CS_CLASSDC;
	wc.lpfnWndProc   = WindowProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance,"MAIN");
	wc.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszMenuName  = "Sample";
	wc.lpszClassName = WINDOW_NAME;
	RegisterClass(&wc);
	
	//======================================================================
	//						   CEBhE쐬
	//======================================================================
	DWORD dwStyle = WS_OVERLAPPED | WS_SYSMENU | WS_CAPTION;
	RECT rc = {0, 0, SCREEN_WIDTH, SCREEN_HEIGHT};
	AdjustWindowRectEx(&rc, dwStyle, FALSE, NULL);
	HWND hwnd = CreateWindowEx(0, WINDOW_NAME, APP_NAME,
						dwStyle,
						CW_USEDEFAULT, CW_USEDEFAULT, 
						rc.right - rc.left, rc.bottom - rc.top,
						NULL, NULL, hInstance, NULL);

	// EChEɎsvOI
	if (!hwnd) return FALSE;
	
	// CX^XnhO[oϐɃRs[
	g_Instance = hInstance;

	// EChE쐬
	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);
	
	// EChE쐬
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	SysMainLoop
//	TvF	Q[[v
//		F	
//	o	F	
////////////////////////////////////////////////////////////////////////////
void SysMainLoop(void)
{
	MSG msg;
	
	// t[^C̏
	g_PreTime = timeGetTime();
	
	while (1)
	{
		//==================================================================
		// bZ[Wꍇ
		//==================================================================
		if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {	
			if (msg.message == WM_QUIT) break;	// AvP[VI

			TranslateMessage(&msg);
			DispatchMessage(&msg);
		} else	{
		//==================================================================
		// Q[C
		//==================================================================
			// t[^C̍XV
			g_FrameTime = (float)(timeGetTime() - g_PreTime) / 1000.0f;
			g_PreTime = timeGetTime();
			
			// Q[C
			GameMain();
		}
	}

	// Q[Ȉ
	GameRelease();
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	SysMainLoop
//	TvF	G[bZ[W\
//		F	*msg	G[bZ[W
//	o	F	
////////////////////////////////////////////////////////////////////////////
void SysErrMsgDisp(char *msg)
{
	MessageBox(g_hwnd, msg, "", MB_OK);
}


////////////////////////////////////////////////////////////////////////////
//	֐	F	SysDirGet
//	TvF	JgfBNg֐
//		F	
//	o	F	st@C܂ł̃pXԂ
////////////////////////////////////////////////////////////////////////////
char* SysDirGet(void)
{
	static int i;
	static char buf[512];
	
	// JgfBNgB̎擾
	GetModuleFileName(g_Instance, buf, 512);

	for (i = strlen(buf); buf[i] != '\\'; i--) buf[i] = NULL;
	
	return buf;
}

////////////////////////////////////////////////////////////////////////////
//	֐	F	SysKeyGet
//	TvF	L[͏֐
//		F	code		zL[R[h
//	o	F	state		L[
//			F	FREE_KEY 	L[ĂȂ
//			F	PUSH_KEY 	L[u
//			F	PULL_KEY 	L[ꂽu
//			F	HOLD_KEY 	L[Ă
////////////////////////////////////////////////////////////////////////////
void SysKeyGet(unsigned int code,int* state)
{
	if ((GetKeyState(code)&0x80) == 0x80) {
	// codeΉL[ꂽ
		if (*state == FREE_KEY) {                    
			*state = PUSH_KEY;
		} else {                                     
			*state = HOLD_KEY;
		}
	} else {
	// L[ĂȂ
		if (*state == PUSH_KEY || *state == HOLD_KEY) { 
			*state = PULL_KEY;
		} else {
			*state = FREE_KEY;
		}	
	}
}
