// x܂ 32bit DIB ̃NX
// DirectX Programmers Page (http://www.interq.or.jp/black/minami-m/) m.minami 
// dib_buf.cpp C^[tF[X킹邽߂ɎQl

#include "win_main.h"
#include "dib_alpha.h"
#include "rpgLoadBmpCode.h"

// TCYw肵ăobt@𐶐
// width		: [IN]	
// height		: [IN]	
CDib2::CDib2(int width, int height)
{
	m_hbmp = NULL;
	
	CreateDib(width, height);
}

// t@Cobt@𐶐
// file_name	: [IN]	t@C
// x, y			: [IN]	ǂݍ݋`̍W
// width		: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height		: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
CDib2::CDib2(char *file_name, int x, int y, int width, int height)
{
	m_hbmp = NULL;
	
	LoadFile(file_name, x, y, width, height);
}

void CDib2::CreateDib(int width, int height)
{
	BITMAPINFO	bi;
	
	m_width  = width;
	m_height = height;

	ZeroMemory(&bi, sizeof(bi));
	bi.bmiHeader.biSize			= sizeof(BITMAPINFOHEADER);
	bi.bmiHeader.biWidth		= width;
	bi.bmiHeader.biHeight		= - height;
	bi.bmiHeader.biPlanes		= 1;
	bi.bmiHeader.biBitCount		= 32;
	bi.bmiHeader.biCompression	= BI_RGB;
	
	m_hbmp = (HBITMAP) CreateDIBSection(NULL, &bi, DIB_RGB_COLORS, (VOID**) &m_buf, NULL, 0);
}

// 摜obt@ɓǂݍ
// file_name	: [IN]	t@C
// x, y			: [IN]	ǂݍ݋`̍W
// width		: [IN]	ǂݍ݋`̕i0 ̏ꍇ͉摜̕j
// height		: [IN]	ǂݍ݋`̍i0 ̏ꍇ͉摜̍j
bool CDib2::LoadFile(char *file_name, int x, int y, int width, int height)
{
	BITMAP	bmp;
	HBITMAP	hBmp;
	
	hBmp = Load_BMP(file_name);
    if (hBmp == NULL) return false;
	
    GetObject(hBmp, sizeof(bmp), &bmp);
    
	if(width <= 0)	width = bmp.bmWidth;
	if(height <= 0)	height = bmp.bmHeight;
	
	CreateDib(width, height);
	
	HDC     hdcCp1,hdcCp2;
	HBITMAP hbmOld1,hbmOld2;
	
	hdcCp1 = CreateCompatibleDC(NULL);
	hdcCp2 = CreateCompatibleDC(NULL);
	hbmOld1 = (HBITMAP)SelectObject(hdcCp1, m_hbmp);
    hbmOld2 = (HBITMAP)SelectObject(hdcCp2, hBmp);
	
	BitBlt(hdcCp1, 0, 0, width, height, hdcCp2, x, y, SRCCOPY);
	
	SelectObject(hdcCp1, hbmOld1);
	SelectObject(hdcCp2, hbmOld2);
	DeleteDC(hdcCp1);
	DeleteDC(hdcCp2);
	DeleteObject(hBmp);
	
	return true;
}

CDib2::~CDib2()
{
	if (m_hbmp) DeleteObject(m_hbmp);
}
