#ifndef __WIN_POP_H__
#define __WIN_POP_H__

#define CLASS_POP 	"CLASS_POP" // |bvAbvEBhẼNX

HWND	g_hPop = NULL;
CDib	*bmPop = NULL;

LRESULT CALLBACK	ProcPopUp(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void				CreatePopUpWindow();
void				Term_WinPop();

// |bvAbvEBhẼvV[W
LRESULT CALLBACK ProcPopUp(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_CREATE:
		g_hPop = hWnd;
		break;
	case WM_CLOSE:
		SAFE_DELETE(bmPop);
		DestroyWindow(hWnd);
		return 0;
	default:
		break;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}// ProcPopUp

// |bvAbvEBhE̍쐬
void CreatePopUpWindow()
{
	WNDCLASSEX	wc;
	HINSTANCE	hInst = GetModuleHandle(NULL);

	ZeroMemory(&wc, sizeof(wc));
	wc.cbSize			= sizeof(WNDCLASSEX); 
	wc.lpfnWndProc		= (WNDPROC) ProcPopUp;
	wc.hInstance		= hInst;
	wc.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszMenuName 	= NULL;
	wc.lpszClassName	= CLASS_POP;
	RegisterClassEx(&wc);
	
	bmPop = new CDib(g_dir.strLoadImage);
	
	if(bmPop){
		int widthDT		= GetSystemMetrics(SM_CXSCREEN);
		int heightDT	= GetSystemMetrics(SM_CYSCREEN);
		int width		= bmPop->GetWidth();
		int height		= bmPop->GetHeight();
		
		int x = (widthDT - width) / 2;
		int y = (heightDT - height) / 2;
		
		HWND hPopUp = CreateWindowEx(	0, 
										CLASS_POP,
										"",
										WS_POPUP | WS_VISIBLE,
										x, y, width, height,
										NULL,
										NULL,
										hInst,
										NULL);
		
		HDC hDC = GetDC(hPopUp);
		
		BitBlt(hDC, 0, 0, bmPop->GetWidth(), bmPop->GetHeight(), bmPop->GetHDC(), 0, 0, SRCCOPY);
		ReleaseDC(hPopUp, hDC);
	}
}// CreatePopUpWindow

void Term_WinPop()
{
	SAFE_DELETE(bmPop);
}// Term_WinPop(

#endif